#define XT_RESOURCE_SEARCH

#define MAX_GROUP	4
#define APPDEFFILE	"XXkb"
#define USERDEFFILE	".xxkbrc"

//#define	When_create	(1<<0)
//#define	When_change	(1<<1)
//#define	Focus_out	(1<<2)
//#define	Two_state	(1<<3)
//#define	Button_enable	(1<<4)
//#define	Main_enable	(1<<5)
//#define	WMaker		(1<<6)
//#define	Button_delete	(1<<7)
//#define	When_start	(1<<8)
//#define	Bell_enable	(1<<9)
//#define	Ignore_reverse	(1<<10)

typedef struct {
  int	mask;
  int	x,y;
  unsigned int width, height;
  int	gravity;
} Geometry;

typedef enum { T_string, T_bool, T_int } ResType;
typedef enum { WMClassClass, WMClassName, WMName} MatchType;
typedef int  ListAction;

#define GrpMask    (0x3)
#define AltGrp     (1<<2)
#define InitAltGrp (1<<3)
#define Ignore     (1<<4)

typedef struct _SearchList {
        struct _SearchList *next;
  ListAction	action;
  MatchType	type;
  int		num;
  char		**idx;
  char		*list;
} SearchList;

typedef struct {
  unsigned int controls;
  int          Base_group, Alt_group;
  int          Bell_percent;
        Geometry     main_geom, but_geom;
        SearchList*  lists[3];
  XImage*      pictures[2*MAX_GROUP];
} XXkbConfig;

void XxkbGetConfig(Display *, XXkbConfig *);

void XxkbReset(void);
void XxkbGetGC(Window win, GC *gc);
void XxkbUpdateWindow(Window win, GC gc, int group);
void XxkbUpdateButton(Window win, GC gc, int group);

Window XxkbMakeButton(Window win, Window parent);
Window XxkbGetGrandParent(Window w);

void XxkbErrHandler(Display *dpy, XErrorEvent* err);

Window XxkbGetIcon(Window win);
Window XxkbGetManagedWindow(Window icon);
void XxkbSaveWindow(Window win, Atom prop_name, Window prop);
